openapi: 3.0.3
info:
  title: Desenvolvimeto Web com Quarkus - OpenAPI 3.0
  description: |-
    Especificação OpenAPI 3.0 do curso Desenvolvimento Web com Quarkus.
  version: 1.0.0
tags:
  - name: prato
    description: Pratos de restaurante
  - name: restaurante
    description: Restaurante
paths:
  /restaurantes:
    get:
      tags:
        - restaurante
      operationId: recuperaRestaurantes
      security:
        - ifood_auth:
          - read:restaurantes
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/Restaurante'
    post:
      tags:
        - restaurante
      operationId: cadastraRestaurante
      security:
        - ifood_auth:
          - write:restaurantes
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CadastroRestaurante'
      responses:
        "201":
          description: Created
  /restaurantes/{idRestaurante}:
    delete:
      tags:
        - restaurante
      operationId: removeRestaurante
      security:
        - ifood_auth:
          - write:restaurantes
      parameters:
        - name: idRestaurante
          in: path
          required: true
          schema:
            type: integer
            format: int64
      responses:
        "204":
          description: No Content
    put:
      tags:
        - restaurante
      operationId: atualizaRestaurante
      security:
        - ifood_auth:
          - write:restaurantes
      parameters:
        - name: idRestaurante
          in: path
          required: true
          schema:
            type: integer
            format: int64
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AtualizacaoRestaurante'
      responses:
        "204":
          description: No Content
  /restaurantes/{idRestaurante}/pratos:
    get:
      tags:
        - prato
        - restaurante
      operationId: recuperaPratosRestaurante
      security:
        - ifood_auth:
          - read:restaurantes
      parameters:
        - name: idRestaurante
          in: path
          required: true
          schema:
            format: int64
            type: integer
      responses:
        "200":
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/Prato'
    post:
      tags:
        - prato
        - restaurante
      operationId: cadastraPratoRestaurante
      security:
        - ifood_auth:
          - write:restaurantes
      parameters:
        - name: idRestaurante
          in: path
          required: true
          schema:
            format: int64
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CadastroPrato'
      responses:
        "201":
          description: Created
  /restaurantes/{idRestaurante}/pratos/{idPrato}:
    delete:
      tags:
        - prato
        - restaurante
      operationId: removePratoRestaurante
      security:
        - ifood_auth:
          - write:restaurantes
      parameters:
        - name: idPrato
          in: path
          required: true
          schema:
            format: int64
            type: integer
        - name: idRestaurante
          in: path
          required: true
          schema:
            format: int64
            type: integer
      responses:
        "204":
          description: No Content
    put:
      tags:
        - prato
        - restaurante
      operationId: atualizaPratoRestaurante
      security:
        - ifood_auth:
          - write:restaurantes
      parameters:
        - name: idPrato
          in: path
          required: true
          schema:
            format: int64
            type: integer
        - name: idRestaurante
          in: path
          required: true
          schema:
            format: int64
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AtualizacaoPrato'
      responses:
        "204":
          description: No Content
components:
  schemas:
    AtualizacaoPrato:
      type: object
      properties:
        nome:
          type: string
        descricao:
          type: string
        preco:
          type: number
          format: double
    AtualizacaoRestaurante:
      type: object
      properties:
        nome:
          type: string
    CadastroPrato:
      type: object
      properties:
        nome:
          type: string
        descricao:
          type: string
        preco:
          type: number
          format: double
    CadastroRestaurante:
      required:
        - cnpj
      type: object
      properties:
        proprietario:
          type: string
        cnpj:
          type: string
          pattern: "[0-9]{2}\\.[0-9]{3}\\.[0-9]{3}\\/[0-9]{4}\\-[0-9]{2}"
        nome:
          type: string
          minLength: 3
          maxLength: 30
        latitude:
          type: number
          format: double
        longitude:
          type: number
          format: double
    Prato:
      properties:
        id:
          type: integer
          format: int64
        nome:
          type: string
        descricao:
          type: string
        preco:
          type: number
          format: double
    Restaurante:
      properties:
        id:
          type: integer
          format: int64
        proprietario:
          type: string
        cnpj:
          type: string
        nome:
          type: string
        latitude:
          type: number
          format: double
        longitude:
          type: number
          format: double
        dataCriacao:
          type: string
          format: date-time
        dataAtualizacao:
          type: string
          format: date-time
  securitySchemes:
    ifood_auth:
      type: oauth2
      flows:
        password:
          tokenUrl: http://localhost:8180/auth/realms/ifood/protocol/openid-connect/token
          scopes:
            write:restaurantes: atualiza restaurantes
            read:restaurantes: recupera restaurantes
